_NewLine equ 452Eh

numItems   equ guiMenuVars
startNum   equ guiMenuVars + 1
selectItem equ guiMenuVars + 2
startData  equ	guiMenuVars + 3
startMenu  equ guiMenuVars + 5
selectAddr equ	guiMenuVars + 7

 globals on
 define _guiMenu_

StartMenu:
 ld		hl,0001h					; Initialize the variables
 ld		(curRow),hl				; and the necessary cursor
 pop		hl							; values
 ld		a,(hl)
 ld		(numItems),a
 inc		hl
 ld		a,(hl)
 ld		(startNum),a
 inc		hl
 ld		a,(hl)
 ld		(selectItem),a   

 inc		hl
 inc		hl							; Over the NULL terminator
 ld		(startMenu),hl			; Changes as scrolling occurs
 ld		(startData),hl			; Doesn't change

DrawMenu:
 ld		a,(numItems)
 cp		7
 jr		z,dm0
 jp		m,dm0
 ld		a,7
dm0:
 ld		b,a
 ld		c,a
 push		bc
 ld		hl,(startMenu)
 ld		de,0001h
 ld		(curRow),de
dm1:
 ld		a,c
 inc		a
 sub		b
 ld		d,a
 ld		a,(startNum)
 add		a,d
 dec		a

 call		SetTextInverse
 call		GetMenuAddr				; Get the address if selected
 inc		hl							; Skip over the address to
 inc		hl							; the menu item name
 push		af
 call		SetNumber
 B_CALL	PutC
 pop		af
 call		SetColonArrow
 B_CALL	PutC
 res		textInverse, (IY+textFlags)
 call		DrawString
 push		af							; Push flags
 B_CALL	EraseEOL
 pop		af
 jr		c,dm2
 B_CALL	NewLine

dm2:
 call		MoveToNextMenu
 djnz		dm1

 pop  	bc							; We now want to clear the
 ld		a,b						; rest of the screen. This is
 cp		7							; necessary on multiple menu
 jr		z,gk						; headers.
 ld		a,7
 sub		a,b
 ld		b,a
 inc		c
 
 ld   	h,0
 ld		l,c
 ld		(curRow),hl

cs0:									; Clear rest of the screen
 B_CALL	EraseEOL
 ld		a,(curRow)
 inc		a
 ld		(curRow),a
 djnz		cs0

gk:
 B_CALL 	GetKey
 cp		kDown
 jp		z,MoveDown
 cp		kUp
 jp		z,MoveUp
 cp		kClear
 jp		z,Exit
 cp		kQuit
 jp		z,Exit
 cp		kEnter
 jp		z,Select
 cp		kLeft
 jp		z,GuiHeadLeft
 cp		kRight
 jp		z,GuiHeadRight

TranslateKey:
 cp	kCapZ
 jp	p,gk
 cp	k0
 jp	m,gk 
 cp	kSpace
 jp	z,gk
 cp	kEE
 jp	z,gk

 sub	k0								; Subtract ASCII for 0

 or	a								; Check for zero
 jr	z,tk0
 cp	9								; Check for 1-9
 jp	m,tk1
 jr	tk2

tk0:									; If zero...
 ld	a,10
 jp	ReSelect

tk1:									; If 1-9
 jp	ReSelect

tk2:									; If A-Z
 sub	1 
 jp	ReSelect 

MoveDown:
 ld		a,(numItems)
 ld		d,a
 ld		a,(selectItem)
 cp		d
 jr		z,md1

 inc		a
 ld		(selectItem), a

 ld		d,a
 ld		a,(startNum)
 add		a,7
 cp		d
 jp		nz, DrawMenu

 ld		hl,(startMenu)
 call		MoveToNextMenu
 ld		(startMenu),hl
 ld		a,(startNum)
 inc		a
 ld		(startNum),a
 jp		DrawMenu

md1:
 bit		0,(iy+29)				; If on auto-repeat
 jp		nz,DrawMenu				; Don't jump
 ld		hl,(startData)
 ld		(startMenu),hl
 ld		a,1
 ld		(startNum),a
 ld		(selectItem),a
 jp		DrawMenu

MoveToNextMenu:					; We search for a NULL terminator
 inc		hl							; and increment HL to the next
 ld		a,(hl)					; byte after it. This should be
 or		a							; the next menu item. No bounds
 jr		z,mtnm0					; checks occur.
 jr		MoveToNextMenu
mtnm0:
 inc		hl
 ret

MoveToPrevMenu:					; 
 dec		hl							; Move past prev NULL terminator
mtpm0:								;
 dec		hl							; Start searching backwards for another
 ld		a,(hl)					;
 or		a							; NULL?
 jr		z,mtpm1					; Jump out of the loop
 jr		mtpm0						; Otherwise, keep searching
mtpm1:								; 
 inc		hl							; Increment HL. HL now points to prev addr
 ret									; Return
 
MoveUp:
 ld	a, (selectItem)
 cp	1
 jr	z, mu2

 dec	a
 ld	(selectItem), a

 ld	d,a
 ld	a,(startNum)
 dec	a
 cp	d
 jp	nz, DrawMenu

 ld		hl,(startMenu)			; Moving up requires altering
 call		MoveToPrevMenu			; startMenu to the previous menu
 ld		(startMenu),hl			; address
 ld		a,(startNum)
 dec		a
 ld		(startNum),a
 jp		DrawMenu
 
mu2:
 bit		0,(iy+29)				; If on auto-repeat
 jp		nz,DrawMenu				; Don't jump
 ld	a,(numItems)
 ld	(selectItem),a
 sub	a,6
 jr	z,mu5
 jp	p,mu6
mu5:
 ld	a,1
mu6:
 ld	(startNum),a

 dec	a
 ld	hl,(startData)
 push	bc
 jr	z,mu4
 jp	m,mu4
 ld	b,a
mu3:
 call	MoveToNextMenu
 djnz	mu3

mu4:
 pop	bc 
 ld	(startMenu),hl

 jp	DrawMenu

ReSelect:
 ld		(selectItem),a			; Store for possible future reference
 ld		hl,(startData)			; Load the start of the menu data
 dec		a							; 
 or		a							; cp 0
 jr		z,rs1						; Jump over djnz if necessary
 ld		b,a						; Set up the byte counter
rs0:									;
 call		MoveToNextMenu			; Move HL
 djnz		rs0						;
rs1:									;
 ex		de,hl						; Next lines equivalent to:
 ld		a,(de)					;    ld hl,(hl)
 ld		l,a						;
 inc		de							;
 ld		a,(de)					;
 ld		h,a						;
 jp		(hl)						; Jump to the address
 
Select:
 ld		hl,(selectAddr)
 jp		(hl)

SetTextInverse:
 push	af
 push	bc
 ld	b,a
 ld	a,(selectItem)
 cp	b
 jr	z, sti1
 res	textInverse, (IY+textFlags)
 jr	sti2
sti1:
 set	textInverse, (IY+textFlags)
sti2:
 pop	bc
 pop	af
 ret

GetMenuAddr:
 push		af
 push		bc
 ld		b,a
 ld		a,(selectItem)
 cp		b
 jr		z,gma0
 pop		bc
 pop		af
 ret		

gma0:
 push		hl
 ex		de,hl
 ld		a,(de)
 ld		l,a
 inc		de
 ld		a,(de)
 ld		h,a
 ld		(selectAddr),hl
 pop		hl
 pop		bc
 pop		af
 ret

SetNumber:
 cp	10
 jp	m,sn1
 jr	z,sn0
 add	a,6
 jr	sn1
 
sn0:
 ld	a,0

sn1:
 add	a,030h
 ret 

SetColonArrow:
 ld	d,a
 ld	a,(startNum)
 cp	d
 jr	z,sca1		; at top of screen

 add	a,6
 cp	d
 jr	nz, sca2	; Inbetween
 ld	a,(numItems)
 cp	d
 jr	z, sca2
 ld	a,1Fh
 ret

sca1:
 cp	1
 jr	z,sca2
 ld	a,1Eh
 ret

sca2:
 ld	a,03Ah
 ret

